      PROGRAM DENSITY
      PARAMETER (NRX=160,NRX2=NRX*NRX,NIOND=60)
      CHARACTER CHAR*1,TITLE*80,LABLE*40,IONS*30
      DIMENSION RHOIN(NRX*NRX*NRX),HKLU(3),HKLV(3),HKLW(3)
      DIMENSION RHO(NRX,NRX,NRX),RHOE(NRX,NRX),ISHIFT(3)
      DIMENSION RALL(NRX2)
      DIMENSION POS(3,NIOND),POSF(4,NIOND)
      DATA ISHIFT /32,32,32/
      DATA NX /64/, NZ /64/, NUMB /64/
C=====================================================================*
C         HORIZONTAL AXIS - PARAMETRIZED BY U                         |
C         VERTICAL   AXIS - PARAMETRIZED BY V                         |
C >>>>>> PLEASE GIVE IN PLANE (X,Y,Z AS A FUNCTION OF U AND V) <<<<<< |
C=====================================================================*
      OPEN(9,FILE='PLANE.M',STATUS='UNKNOWN')
      OPEN(7,FILE='CHG',STATUS='OLD')
      OPEN(4,FILE='PLANE',STATUS='UNKNOWN')
      OPEN(8,FILE='HKL',STATUS='OLD')
      RHOMAX=-1E30
      RHOMIN=1E30
      RMAX=RHOMAX
      RMIN=RHOMIN
      READ(8,'(A)') LABLE
C      WRITE(5,*) 'NXF, NZF (Ausschnitt in beide Richtungen)'
      READ(8,*,END=2387,ERR=2387) NX,NZ
C      WRITE(5,*) 'UX, UY, UZ (1. Richtung)'
      READ(8,*,END=2387,ERR=2387) HKLU(1),HKLU(2),HKLU(3)
C      WRITE(5,*) 'VX, VY, VZ (2. Richtung)'
      READ(8,*,END=2387,ERR=2387) HKLV(1),HKLV(2),HKLV(3)
C      WRITE(5,*) 'DX, DY, DZ (Ursprung)'
      READ(8,*,END=2387,ERR=2387) ISHIFT(1),ISHIFT(2),ISHIFT(3)
      READ(8,*,END=2387,ERR=2387) RHOMAX
 2387 CONTINUE
      HKLW(1)=HKLU(2)*HKLV(3)-HKLU(3)*HKLV(2)
      HKLW(2)=HKLU(3)*HKLV(1)-HKLU(1)*HKLV(3)
      HKLW(3)=HKLU(1)*HKLV(2)-HKLU(2)*HKLV(1)
      UNORM=HKLU(1)**2+HKLU(2)**2+HKLU(3)**2
      VNORM=HKLV(1)**2+HKLV(2)**2+HKLV(3)**2
      WNORM=HKLW(1)**2+HKLW(2)**2+HKLW(3)**2

      WRITE(*,*) 'PROGRAM DENSHKL'
      WRITE(*,*) LABLE
      WRITE(*,*) 'NX=',NX,', NZ=',NZ
      WRITE(*,'(A2,3F7.3)') 'U=',HKLU(1),HKLU(2),HKLU(3)
      WRITE(*,'(A2,3F7.3)') 'V=',HKLV(1),HKLV(2),HKLV(3)
      WRITE(*,'(A2,3F7.3)') 'W=',HKLW(1),HKLW(2),HKLW(3)
      WRITE(*,*) 'ISHIFT=',ISHIFT(1),ISHIFT(2),ISHIFT(3)
      READ(7,'(A)') TITLE
      READ(7,*) SCALE
      READ(7,*) A11,A21,A31
      READ(7,*) A12,A22,A32
      READ(7,*) A13,A23,A33
      OMEGA=(A21*A32-A31*A22)*A13+(A31*A12-A11*A32)*A23+
     &      (A11*A22-A21*A12)*A33*SCALE**3
      WRITE(*,*) 'volume of the cell=',OMEGA
      READ(7,'(A)') IONS
      IONS=IONS(:20)//'0 0 0'
      READ(IONS,*) I1,I2,I3,I4
      NUMB=I1+I2+I3+I4
      WRITE(*,*) 'Number of Ions = ',NUMB
      READ(7,'(A)') CHAR
      IF (CHAR.EQ.'D'.OR.CHAR.EQ.'d') THEN
        WRITE(*,*) 'coordinats direct'
      ELSE
        WRITE(*,*) CHAR
        WRITE(*,*) 'coordinats carthesian'
        WRITE(*,*) 'Sorry, not implemented yet  ...'
        STOP
      ENDIF
      DO 99 I=1,NUMB
         READ(7,*) (POS(II,I),II=1,3)
   99 CONTINUE

      READ(7,*) NR1,NR2,NR3
      IF ((NR1.GT.NRX).OR.(NR2.GT.NRX).OR.(NR3.GT.NRX)) THEN
         WRITE(*,*) ' Error! Too large NR''s on unit 7 ! ',NR1,NR2,NR3
         STOP
      END IF

      READ(7,'(10F8.3)') (RHOIN(I),I=1,NR1*NR2*NR3)
      I=0
      DO 12346 IZ=0,NR3-1
       IR3=MOD(IZ+ISHIFT(3)+12*NR3,NR3)+1
       DO 12346 IY=0,NR2-1
        IR2=MOD(IY+ISHIFT(2)+12*NR2,NR2)+1
        DO 12346 IX=0,NR1-1
         IR1=MOD(IX+ISHIFT(1)+12*NR1,NR1)+1
         I=I+1
         RHODUM=RHOIN(I)/OMEGA
         IF (RHODUM.GT.RHOMAX) RHOMAX=RHODUM
         IF (RHODUM.LT.RHOMIN) RHOMIN=RHODUM
         RHO(IR1,IR2,IR3)=RHODUM
12346 CONTINUE
      ICOUNT=0
      DO 100 IV=0,NZ-1
       DO 100 IU=0,NX-1
         CALL PLANE(NR1,NR2,NR3,IU,IV,IX,IY,IZ,HKLU,HKLV)
         RHODUM=RHO(IX,IY,IZ)
CCC         IF (RHODUM.LT.0.) RHODUM=0.
         IF (RHODUM.GT.RMAX) RMAX=RHODUM
         IF (RHODUM.LT.RMIN) RMIN=RHODUM
         ICOUNT=ICOUNT+1
         RALL(ICOUNT)=RHODUM
  100 CONTINUE
CCC      IF (RHOMIN.LT.0.) RHOMIN=0.
CCC      RHOMIN=0
      DO 150 KZ=1,NZ
       DO 150 KX=1,NX
  150 RHOE(KX,KZ)=(RALL(KX+(KZ-1)*NX)-RHOMIN)/(RHOMAX-RHOMIN)
      WRITE(9,'(A)') LABLE
      WRITE(9,'(I4,I4)') NX,NZ
      WRITE(9,2) RHOMIN,RHOMAX
      WRITE(9,3) HKLU(1),HKLU(2),HKLU(3)
      WRITE(9,3) HKLV(1),HKLV(2),HKLV(3)
      WRITE(9,'(3I5)') ISHIFT(1),ISHIFT(2),ISHIFT(3)
      WRITE(4,'(I4,I4)') NX,NZ
      DO 165 KZ=1,NZ
       DO 165 KX=1,NX
        WRITE(9,'(F5.3)') RHOE(KX,KZ)
  165   WRITE(4,3) FLOAT(KX-1)/FLOAT(NX),FLOAT(KZ-1)/FLOAT(NZ),
     &             RHOE(KX,KZ)
      WRITE(4,2) RHOMIN
      WRITE(4,2) RHOMAX
      WRITE(4,'(A)') LABLE
    2 FORMAT(E24.16)
    3 FORMAT(3E24.16)
      WRITE(*,159) RHOMAX,RHOMIN,RMAX,RMIN
  159 FORMAT('  RHOMAX=',E10.4,';     RHOMIN=',E10.4,'  (GLOBAL)'/
     &       '  RMAX  =',E10.4,';     RMIN  =',E10.4,'  (LOCAL )')

C now for the atoms
      DO I=1,NUMB
        POS(1,I)=POS(1,I)*NR1+ISHIFT(1)
        POS(2,I)=POS(2,I)*NR2+ISHIFT(2)
        POS(3,I)=POS(3,I)*NR3+ISHIFT(3)
      ENDDO

      ICOUNT=0
      DO 200 I=1,NUMB
      DO 200 IX=-3,3
      DO 200 IY=-3,3
      DO 200 IZ=-3,3
        PX=POS(1,I)+IX*NR1
        PY=POS(2,I)+IY*NR2
        PZ=POS(3,I)+IZ*NR3
        E=(PX*HKLW(1)+PY*HKLW(2)+PZ*HKLW(3))/WNORM
        IF (ABS(E).LT.3) THEN
          PU=PX*HKLU(1)+PY*HKLU(2)+PZ*HKLU(3)
          PU=PU/UNORM+1
          PV=PX*HKLV(1)+PY*HKLV(2)+PZ*HKLV(3)
          PV=PV/VNORM+1
C here you can say which atoms you want
C if you want only atoms in the cell, then write
C ...GE.1.AND....LE.NX (NZ)
          IF (PU.GE.-1.AND.PU.LE.(NX+2).AND.
     &        PV.GE.-1.AND.PV.LE.(NZ+2)) THEN
            ICOUNT=ICOUNT+1
            IF (ICOUNT.GT.NIOND) THEN
              WRITE(*,*) 'Too many atoms in plane ...'
              WRITE(*,*) 'Increase NIOND (POSF)'
              STOP
            ENDIF
            POSF(1,ICOUNT)=PU
            POSF(2,ICOUNT)=PV
            POSF(3,ICOUNT)=E
            POSF(4,ICOUNT)=I
          ENDIF
        ENDIF
 200  CONTINUE
      WRITE(9,*) ICOUNT
      WRITE(*,*) ICOUNT,' atoms (more or less) in the plane'
      WRITE(*,*)
      DO I=1,ICOUNT
        WRITE(9,'(3F9.2,F6.1)') (POSF(II,I),II=1,4)
      ENDDO

C calculate the real lenghts of the selected cell
      NX=NX-1
      NZ=NZ-1
      X=HKLU(1)*NX/NR1*A11+HKLU(2)*NX/NR2*A12+HKLU(3)*NX/NR3*A13
      Y=HKLU(1)*NX/NR1*A21+HKLU(2)*NX/NR2*A22+HKLU(3)*NX/NR3*A23
      Z=HKLU(1)*NX/NR1*A31+HKLU(2)*NX/NR2*A32+HKLU(3)*NX/NR3*A33
      ULEN=SQRT(X**2+Y**2+Z**2)*SCALE
      X=HKLV(1)*NZ/NR1*A11+HKLV(2)*NZ/NR2*A12+HKLV(3)*NZ/NR3*A13
      Y=HKLV(1)*NZ/NR1*A21+HKLV(2)*NZ/NR2*A22+HKLV(3)*NZ/NR3*A23
      Z=HKLV(1)*NZ/NR1*A31+HKLV(2)*NZ/NR2*A32+HKLV(3)*NZ/NR3*A33
      VLEN=SQRT(X**2+Y**2+Z**2)*SCALE
      WRITE(9,'(2F10.3)') ULEN,VLEN

      END

C***********************************************************************
      SUBROUTINE PLANE(NR1,NR2,NR3,IU,IV,IX,IY,IZ,HKLU,HKLV)
      DIMENSION HKLU(3),HKLV(3)
C Defines plane ... :
C NEW!!! correct rounding! -GK
C only important for atoms
      X=IU*HKLU(1)+IV*HKLV(1)
      Y=IU*HKLU(2)+IV*HKLV(2)
      Z=IU*HKLU(3)+IV*HKLV(3)
      IX=MOD(INT(X+.5+12*NR1),NR1)+1
      IY=MOD(INT(Y+.5+12*NR2),NR2)+1
      IZ=MOD(INT(Z+.5+12*NR3),NR3)+1
      RETURN
      END
