********************************************************************
*
*    Berechnet K-Punktraster 
*    VERSION Februar 1991 by KRESSE GEORG
*    modified October 1994 by EICHLER Andreas
*
*********************************************************************
                                        
      PROGRAM KGEN

      IMPLICIT REAL*8 (A-H,O-Z)
      CHARACTER NAME*40                   
      PARAMETER (NDIR=10,NPROJMAX=20)
      DIMENSION QK1(NDIR,3),QK2(NDIR,3),STEP(NDIR),BV(3),IPDIR(3)
      CHARACTER *10 TEXT(NDIR)

      OPEN(1,FILE='BANDCTR',STATUS='OLD',ERR=100)
      READ(1,'(A)') NAME
      READ(1,*) ND
      READ(1,*) NN
      DO 20 I=1,ND  
        READ(1,*) TEXT(I),STEP(I)
        READ(1,*) (QK1(I,J),J=1,3)
        READ(1,*) (QK2(I,J),J=1,3)
   20 CONTINUE
      READ(1,*) TEXT(I)
      NPROJ=1
      READ(1,*,ERR=25,END=25) RDUM1
      READ(1,*,ERR=25,END=25) IDUM
      READ(1,*,ERR=25,END=25) IPDIR(1),IPDIR(2),IPDIR(3),
     &     PSTART,PEND,NPROJ
   25 CLOSE(1)

      IF (ABS(IDIR).GE.999.OR.NPROJ.GT.NPROJMAX.OR.NPROJ.LT.0) THEN
         WRITE(*,*) 'Invalid choice for IDIR or NPROJ !'
         STOP
      ENDIF
      IF (NPROJ.LT.2) NPROJ=1
      PDIR=SQRT(IPDIR(1)**2.+IPDIR(2)**2.+IPDIR(3)**2.)
      IF (PDIR.LT.1E-2) PDIR=1.
      PSTART=PSTART/PDIR
      PEND=PEND/PDIR
      PSTEP=(PEND-PSTART)/MAX(1,(NPROJ-1))
      
      OPEN(1,FILE='KPOINTS')
      WRITE(1,2) NN*ND*NPROJ
   2  FORMAT('kpoints from kgen'/
     &        I4/
     &       'reziprok')

      NNM1=NN-1
      DO 30 N=1,ND
      WRITE(1,*)
      DO 30 I=1,NN
       DO 30  NP=0,NPROJ-1
          DO 35 J=1,3
           BV(J)=((I-1)*QK2(N,J)+(NN-I)*QK1(N,J))/NNM1+
     &          IPDIR(J)*(PSTEP*NP+PSTART)
   35    CONTINUE
   30 WRITE(1,'(3F9.5,4X,I1)') (BV(J),J=1,3),1
      CLOSE(1)
      GOTO 1000

  100 WRITE(*,*) 'Could not open file BANDCTR'
      STOP
 1000 CONTINUE
      END














