********************************************************************
*
*     Porgram zum Zeichnen von dos
*
*********************************************************************

      PROGRAM DRAWCH
      PARAMETER (NRX=128,NCTR=10)
      DIMENSION RHO(NRX*NRX),CTR(NCTR)
      DIMENSION DSH1(3),DSH2(3),DSH3(3)
      CHARACTER TYPO*8,TITLE*80

      WRITE(*,*)'Program DRAWCHG'

      CALL INIT

      OPEN(7,FILE='PLANE',STATUS='OLD')
      DO 10 I=1,NCTR
   10 CTR(I)=(FLOAT(I)-0.5)/FLOAT(NCTR)

C--------------------------------------------------------------------
C     read data
C--------------------------------------------------------------------

      READ(7,*) NX,NZ
      I=0
      DO 100 IZ=1,NZ
       DO 100 IX=1,NX
         I=I+1
         READ(7,*) X,Y,RHO(I)
  100 CONTINUE
      READ(7,*) RHOMIN
      READ(7,*) RHOMAX
      READ(7,'(A)') TITLE

C--------------------------------------------------------------------
C  initialise all
C--------------------------------------------------------------------

      XMIN=0.0
      XMAX=1.0
      YMIN=0.0
      YMAX=1.0
      PXMAX = 18.0000
      PYMAX = 25.4558

      CALL READIN(PXMAX,PYMAX,XLEFT,YBOTT,XRIGHT,YTOP,ITEXT,
     &            ' ',' ',XMIN,XMAX,YMIN,YMAX,
     &            IDSH,DSH1,DSH2,DSH3,CHO1,CHO2)

C-----Subformat definieren
      CALL HISUBF(XLEFT,YBOTT,
     &            PXMAX-XRIGHT-XLEFT,PYMAX-YTOP-YBOTT-4.*CHO1)

      CALL XBOUND(XMIN,XMAX)
      CALL YBOUND(YMIN,YMAX)

      CALL PLFRAM

      IF (ITEXT.NE.0) THEN
        SCALEX=PXMAX-XRIGHT-XLEFT
        SCALEY=PYMAX-YTOP-YBOTT
        CALL MOVET(XMIN,YMAX)
        CALL MOVED(0.,SCALEY*0.02)
        CALL SETTHI(CHO2)
        CALL PLTEXT(TITLE,80)
        WRITE(*,'(A)') TITLE
      ENDIF

      CALL HILIMT

C--------------------------------------------------------------------
C     plot charge now
C--------------------------------------------------------------------

      CALL SETCTR(CTR,NCTR)
      CALL CTRRA(RHO,NX,NZ,0.,1.,0.,1.)

      CALL PLOTCL

      END
