      PROGRAM MERGEEIG
      PARAMETER(NKDIM=100001,NBANDM=100001,TINY=1.E-6)
      CHARACTER*40 HEAD,TYPE,EIGNAM,FORM
      CHARACTER*80 HEADER(5)
      DIMENSION VKPT(3,NKDIM),WTKPT(NKDIM),EIGVAL(NBANDM),VKP(3)

      OPEN(20,FILE='KPOINTS',ERR=10000,STATUS='OLD')
      READ(20,'(A)',ERR=10000,END=10000) HEAD
      READ(20,*,ERR=10000,END=10000) NKPTS
      IF (NKPTS.GT.NKDIM) THEN
         WRITE(*,*) 'NKPTS greater than NKDIM, check ...'
         STOP
      ENDIF
      READ(20,'(A)',ERR=10000,END=10000) TYPE
      WEISUM=0.
      DO 10 NK=1,NKPTS
         READ(20,*,ERR=10000,END=10000) (VKPT(I,NK),I=1,3),WTKPT(NK)
         WEISUM=WEISUM+WTKPT(NK)
   10 CONTINUE
      CLOSE(20)

      OPEN(21,FILE='EIGENVAL')

      DO 100 NK=1,NKPTS
         L=INT(LOG10(FLOAT(NK)))+1
         WRITE(FORM,'(A,I1,A)') '(A,I',L,')'
         WRITE(EIGNAM,FORM) 'EIGENVAL.',NK
         WRITE(*,*) 'Reading file ',EIGNAM

         OPEN(20,FILE=EIGNAM,STATUS='OLD',ERR=20000)
         DO 20 I=1,5
            READ(20,'(A)',ERR=20000,END=20000) HEADER(I)
   20    CONTINUE
         READ(20,*,ERR=20000,END=20000) NEL,NKPDUM,NBANDS
         IF (NBANDS.GT.NBANDM) THEN
            WRITE(*,*) 'NBANDS greater than NBANDM, check ...'
            STOP
         ENDIF
         READ(20,'(A)',ERR=20000,END=20000) HEAD
         READ(20,*,ERR=20000,END=20000) VKP(1),VKP(2),VKP(3),WKP
* Not a perfect 'check' ...
         IF (((TYPE(1:1).EQ.'R').OR.(TYPE(1:1).EQ.'r')).AND.
     &      ((ABS(VKP(1)-VKPT(1,NK)).GT.TINY).OR.
     &       (ABS(VKP(2)-VKPT(2,NK)).GT.TINY).OR.
     &       (ABS(VKP(3)-VKPT(3,NK)).GT.TINY))) GOTO 30000
         DO 30 I=1,NBANDS
            READ(20,*,ERR=20000,END=20000) NDUM,EIGVAL(I)
   30    CONTINUE
         CLOSE(20)

         IF (NK.EQ.1) THEN
            DO 60 I=1,5
               WRITE(21,'(A)') HEADER(I)
   60       CONTINUE
            WRITE(21,'(3I8)') NEL,NKPTS,NBANDS
         ENDIF
         WRITE(21,'(A)')
         WRITE(21,'(4E14.7)') (VKP(I),I=1,3),WTKPT(NK)/WEISUM
         DO 70 I=1,NBANDS
            WRITE(21,'(I4,F14.4)') I,EIGVAL(I)
   70    CONTINUE

  100 CONTINUE
      CLOSE(21)

      GOTO 99999
10000 WRITE(*,*) 'Error opening or reading file KPOINTS.'
      CLOSE(20)
      STOP
20000 WRITE(*,*) 'Error opening or reading file ',EIGNAM
      CLOSE(20)
      STOP
30000 WRITE(*,*) 'Incompatible k-points on files.'
      STOP
99999 CONTINUE
      END
