      PROGRAM MERGEPRO
      PARAMETER(NKDIM=100001,NBIDIM=1000001,LDIMP=3,NBANDM=100001)
      PARAMETER(TINY=1.E-6)
      CHARACTER*80 HEAD,TYPE,PRONAM,FORM
      DIMENSION VKPT(3,NKDIM),WTKPT(NKDIM),VKP(3),
     &          PAR(NBIDIM*(LDIMP+1)),EIG(NBANDM),FERWE(NBANDM)

      OPEN(20,FILE='KPOINTS',ERR=10000,STATUS='OLD')
      READ(20,'(A)',ERR=10000,END=10000) HEAD
      READ(20,*,ERR=10000,END=10000) NKPTS
      IF (NKPTS.GT.NKDIM) THEN
         WRITE(*,*) 'NKPTS greater than NKDIM, check ...'
         STOP
      ENDIF
      READ(20,'(A)',ERR=10000,END=10000) TYPE
      WEISUM=0.
      DO 10 NK=1,NKPTS
         READ(20,*,ERR=10000,END=10000) (VKPT(I,NK),I=1,3),WTKPT(NK)
         WEISUM=WEISUM+WTKPT(NK)
   10 CONTINUE
      CLOSE(20)

      OPEN(21,FILE='PROCAR')

      DO 100 NK=1,NKPTS
         L=INT(LOG10(FLOAT(NK)))+1
         WRITE(FORM,'(A,I1,A)') '(A,I',L,')'
         WRITE(PRONAM,FORM) 'PROCAR.',NK
         WRITE(*,*) 'Reading file ',PRONAM

         OPEN(20,FILE=PRONAM,STATUS='OLD',ERR=20000)
         READ(20,300,ERR=20000,END=20000) NKPDUM,NBANDS,NIONS
         IF (NBANDS.GT.NBANDM) THEN
            WRITE(*,*) 'NBANDS greater than NBANDM, check ...'
            STOP
         ENDIF
         IF ((NBANDS*(NIONS+1)).GT.NBIDIM) THEN
            WRITE(*,*)
     &      'NBANDS*(1+NIONS) greater than NBIDIM, check ...'
            STOP
         ENDIF
         READ(20,'(A1)',ERR=20000,END=20000) HEAD
         READ(20,301,ERR=20000,END=20000) IDUM,VKP(1),VKP(2),VKP(3),WKP
* Not a perfect 'check' ...
         IF (((TYPE(1:1).EQ.'R').OR.(TYPE(1:1).EQ.'r')).AND.
     &      ((ABS(VKP(1)-VKPT(1,NK)).GT.TINY).OR.
     &       (ABS(VKP(2)-VKPT(2,NK)).GT.TINY).OR.
     &       (ABS(VKP(3)-VKPT(3,NK)).GT.TINY))) GOTO 30000
         READ(20,'(A1)',ERR=20000,END=20000) HEAD
         READ(20,'(A1)',ERR=20000,END=20000) HEAD
         DO 30 I=1,NBANDS
            READ(20,203,ERR=20000,END=20000) NDUM,EIG(I),FERWE(I),
     &         IDUM,(PAR((I-1)*(NIONS+1)*(LDIMP+1)+J),J=1,LDIMP+1)
            DO 20 NI=2,NIONS
               READ(20,204,ERR=20000,END=20000) IDUM,
     &         (PAR(((I-1)*(NIONS+1)+(NI-1))*(LDIMP+1)+J),J=1,LDIMP+1)
   20       CONTINUE
            IF (NIONS.GT.1) THEN
               READ(20,305,ERR=20000,END=20000)
     &          (PAR(((I-1)*(NIONS+1)+NIONS)*(LDIMP+1)+J),J=1,LDIMP+1)
               READ(20,'(A1)',ERR=20000,END=20000) HEAD
            ENDIF
   30    CONTINUE
         CLOSE(20)

         IF (NK.EQ.1) THEN
            WRITE(21,200) NKPTS,NBANDS,NIONS
         ENDIF
         WRITE(21,201) NK,(VKP(I),I=1,3),WTKPT(NK)/WEISUM
         WRITE(21,202)
         DO 70 I=1,NBANDS
            WRITE(21,203) I,EIG(I),FERWE(I),1,
     &         (PAR((I-1)*(NIONS+1)*(LDIMP+1)+J),J=1,LDIMP+1)
            DO 60 NI=2,NIONS
               WRITE(21,204) NI,
     &         (PAR(((I-1)*(NIONS+1)+(NI-1))*(LDIMP+1)+J),J=1,LDIMP+1)
   60       CONTINUE
            IF (NIONS.GT.1) WRITE(21,205)
     &         (PAR(((I-1)*(NIONS+1)+NIONS)*(LDIMP+1)+J),J=1,LDIMP+1)
   70    CONTINUE

  100 CONTINUE
      CLOSE(21)

  200 FORMAT('# of k-points:',I5,9X,'# of bands:',I4,9X,'# of ions:',I4)
  201 FORMAT(/' k-point ',I4,' :',3X,3F11.8,'     weight = ',F10.8/)
  202 FORMAT('  band     band energy   occupation   ion        s            
     &  p          d         tot')
  203 FORMAT(3X,I3,2X,F14.8,3X,F10.8,3X,I3,2X,3(1X,F10.8),2X,F6.3)
  204 FORMAT(38X,I3,2X,3(1X,F10.8),2X,F6.3)
  205 FORMAT(38X,'tot',2X,3(1X,F10.8),2X,F6.3/)

  300 FORMAT(14X,I5,20X,I4,19X,I4)
  301 FORMAT(9X,I4,5X,3F11.8,14X,F10.8)
  305 FORMAT(43X,3(1X,F10.8),2X,F6.3)

      GOTO 99999
10000 WRITE(*,*) 'Error opening or reading file KPOINTS.'
      CLOSE(20)
      STOP
20000 WRITE(*,*) 'Error opening or reading file ',PRONAM
      CLOSE(20)
      STOP
30000 WRITE(*,*) 'Incompatible k-points on files.'
      STOP
99999 CONTINUE
      END
