********************************************************************
*
*     Read INI-File
*
********************************************************************
      
 
      SUBROUTINE READIN(PXMAX,PYMAX,XLEFT,YBOTT,XRIGHT,YTOP,ITEXT,
     &            TEXTL,TEXTB,
     &            XMIN,XMAX,FMIN,FMAX,
     &            IDSH,DSH1,DSH2,DSH3,CHO1,CHO2)
      DIMENSION DSH1(3),DSH2(3),DSH3(3)
      CHARACTER*40 SZ
      CHARACTER*(*) TEXTL,TEXTB
                         
      DSH1(1)=0.3
      DSH1(2)=0.3
      DSH1(3)=0.3

      DSH2(1)=0.4
      DSH2(2)=0.1
      DSH2(3)=0.4

      DSH3(1)=0.3
      DSH3(2)=0.2
      DSH3(3)=0.1

      STRST=0.0   
      CHO1=0.5
      CHO2=0.2 
      XLEFT=2.5
      YBOTT=2.5 
      DAX=1.1
      IDSH =1 
      ITEXT=1

      OPEN(87,FILE='PLOPINI',STATUS='OLD',ERR=100)
      READ(87,*,ERR=5) PXMAX,PYMAX
    5 READ(87,*,ERR=10) XLEFT,YBOTT
   10 READ(87,'(A40)')  SZ
      READ(SZ,*,ERR=11,END=11) F1
      READ(SZ,*,ERR=12,END=12) F1,F2
      READ(SZ,*,ERR=13,END=13) F1,F2,F3
      READ(SZ,*,ERR=14,END=14) F1,F2,F3,F4
      XMAX=F4 
   14 XMIN=F3
   13 FMAX=F2
   12 FMIN=F1
   11 CONTINUE

   20 READ(87,*,ERR=25) ITEXT
   25 READ(87,*,ERR=30) IDSH
   30 READ(87,*,ERR=35) STRST
   35 READ(87,*,ERR=40) DSH1
   40 READ(87,*,ERR=50) DSH2
   50 READ(87,*,ERR=60) DSH3      
   60 READ(87,*,ERR=70) CHO1
   70 READ(87,*,ERR=75) CHO2      
   75 READ(87,*,ERR=90) DAX
   90 CONTINUE

      CLOSE(87)
 100  CONTINUE    
               
      XRIGHT=0.5
      YTOP  =0.5  

      CALL HIUFMT(PXMAX,PYMAX)
      CALL NO64CS             
      IF (STRST.NE.0) CALL SETLTH(STRST)  
      CALL SETTHI(CHO1)
      CALL SETCHA(1.0,0.0,1.0,CHO1,0.0)
      CALL SETDAX(DAX)
             
      CALL SETTAN(3.1425/2)
      ILEN=LEN(TEXTL)
      CALL FTXEXT( TEXTL,ILEN,DELTAX,DELTAY)
      CALL MOVE(CHO1+.2,YBOTT+(PYMAX-YBOTT-YTOP)/2-DELTAY/2-CHO1*2)
      CALL PLTEXT(TEXTL,ILEN) 

      CALL SETTAN(0.0) 
      ILEN=LEN(TEXTB)
      CALL FTXEXT( TEXTB,ILEN,DELTAX,DELTAY)
      CALL MOVE(XLEFT+(PXMAX-XLEFT-YBOTT)/2-DELTAX/2+CHO1*2,.2)
      CALL PLTEXT(TEXTB,ILEN) 
      RETURN
      END

      SUBROUTINE SHEAD(LINE,PYMAX,CHO,TEXT)
      CHARACTER*(*) TEXT  
      CALL MOVE(2.,PYMAX-(.1+CHO)*LINE)   
      IF (LEN(TEXT).NE.0) THEN
      CALL PLTEXT(TEXT,LEN(TEXT))
      ENDIF
      RETURN
      END 

      SUBROUTINE SSUBR(CHO,TEXT,XMAX,FMAX)
      CHARACTER*(*) TEXT   
      CHOT=CHO*1.2
      CALL SETTHI (CHOT)
      ILEN=LEN(TEXT) 
      CALL MOVET(XMAX,FMAX)
      CALL MOVED(-(ILEN+.5)*CHOT,-CHOT*1.5) 
      CALL PLTEXT(TEXT,LEN(TEXT))
      CALL SETTHI(CHO)
      RETURN
      END   

      SUBROUTINE SSUBL(CHO,TEXT,XMIN,FMAX)
      CHARACTER*(*) TEXT   
      CHOT=CHO*1.2
      CALL SETTHI (CHOT)
      ILEN=LEN(TEXT) 
      CALL MOVET(XMIN,FMAX)
      CALL MOVED(CHOT,-CHOT*1.5) 
      CALL PLTEXT(TEXT,LEN(TEXT))
      CALL SETTHI(CHO)
      RETURN
      END
