      PROGRAM SPLITK
      PARAMETER(NKDIM=100001)
      CHARACTER*40 HEAD,TYPE,KPTNAM,FORM
      DIMENSION VKPT(3,NKDIM),WTKPT(NKDIM)

      OPEN(20,FILE='KPOINTS',ERR=10000,STATUS='OLD')
      READ(20,'(A)',ERR=10000,END=10000) HEAD
      READ(20,*,ERR=10000,END=10000) NKPTS
      IF (NKPTS.GT.NKDIM) THEN
         WRITE(*,*) 'NKPTS greater than NKDIM, check ...'
         STOP
      ENDIF
      READ(20,'(A)',ERR=10000,END=10000) TYPE
      WEISUM=0.
      DO 10 NK=1,NKPTS
         READ(20,*,ERR=10000,END=10000) (VKPT(I,NK),I=1,3),WTKPT(NK)
         WEISUM=WEISUM+WTKPT(NK)
   10 CONTINUE
      CLOSE(20)

      DO 100 NK=1,NKPTS
         L=INT(LOG10(FLOAT(NK)))+1
         WRITE(FORM,'(A,I1,A)') '(A,I',L,')'
         WRITE(KPTNAM,FORM) 'KPOINTS.',NK
         WRITE(*,*) 'Writing file ',KPTNAM
         OPEN(20,FILE=KPTNAM)
         WRITE(20,'(A)') HEAD
         WRITE(20,'(I3)') 1
         WRITE(20,'(A)') TYPE
         WRITE(20,'(4F20.16)') (VKPT(I,NK),I=1,3),WTKPT(NK)/WEISUM
         CLOSE(20)
  100 CONTINUE

      GOTO 99999
10000 WRITE(*,*) 'Error opening or reading file KPOINTS.'
      CLOSE(20)
      STOP
99999 CONTINUE
      END
